from xml.sax.saxutils import XMLFilterBase, prepare_input_source
import os
import xml.sax
from xml.sax.xmlreader import InputSource

try:
	from cStringIO import StringIO
except ImportError:
	from StringIO import StringIO

class Parser(XMLFilterBase): #pylint: disable-msg=R0904
	def __init__(self, xmlData):
		"""xmlData is either a filename, or the xml content as a string"""
		xml.sax.saxutils.XMLFilterBase.__init__(self)

		self.xmlData = xmlData

		# create parser
		self.parser = xml.sax.make_parser()

		self.parser.setContentHandler(self)
		self.parser.setDTDHandler(self)
		self.parser.setErrorHandler(self)
		self.parser.setEntityResolver(self)

	def resolveEntity(self, public, system): #pylint: disable-msg=W0613, C0103
		return prepare_input_source(os.path.join(os.path.dirname(__file__), os.path.basename(system)))

	# error handler events
	#---------------------------------------------------------------------------
	def error(self, exception): #cover[no]
		print('Error from parser=<%s>' % (exception,))
		raise exception

	def fatalError(self, exception): #cover[no] pylint: disable-msg=W0613, C0103
		print('Fatal error from parser=<%s>' % (exception,))
		raise exception

	def warning(self, exception): #cover[no]
		print('Warning from parser=<%s>' % (exception,))

	# document handler events
	#---------------------------------------------------------------------------
	def startElement(self, name, attributes): #pylint: disable-msg=C0103
		print 'Parser.startELement', name, attributes
		if attributes.getLength():
			print '     items:', attributes.items()
			print '     values:', attributes.values()
			print '     Parser.startELement names:', attributes.getNames()
			print '     Parser.startELement Qnames:', attributes.getQNames()
			for name in attributes.getNames():
				print "     name ", name
				print '          getType %s'% (attributes.getType(name))
				print '          getQNameByName %s'% (attributes.getQNameByName(name))
				
			
		attributes = dict(attributes)
		print '   Parser.startELement (after dict)', name, attributes
		
	def endElement(self, name):  #pylint: disable-msg=W0613, C0103
		pass

	
	# public interface
	#---------------------------------------------------------------------------
	def __getDataStr(self):
		self.depth = 0
		inpsrc = InputSource()
		inpsrc.setByteStream(StringIO(self.xmlData))
		self.parser.parse(inpsrc)

	def getData(self): #pylint: disable-msg=C0103
		return self.__getDataStr()

xml_data = """<?xml version="1.0" encoding="UTF-8"?>
<library>
   <book language="fr" isbn="4567" >
      <title>
	La belle au bois dormant
      </title>
      <available from="monday" to="friday"/>
   </book>
 </library>
"""

parser = Parser(xml_data)
parser.getData()
